#ifndef __CAMERA_H__
#define __CAMERA_H__

/*#define CAMERA_FORWARD 0
#define CAMERA_BACKWARD 1
#define CAMERA_STRAFERIGHT 2
#define CAMERA_STRAFELEFT 3
#define CAMERA_ROTRIGHT 4
#define CAMERA_ROTLEFT 5*/

#define CAMERA_CONTROL_CAMERA 0
#define CAMERA_CONTROL_TERRAIN 1

/* Type : camera_t
 * contient les informations relatives  la camra :
 *  - sa position
 *  - le vecteur pointant dans la direction o l'on regarde
 *  - le vecteur pointant vers la haut (perp.  celui ci dessus)
 */
typedef struct camera_t
{

  vector3d_t position;
  vector3d_t view;
  vector3d_t upVector;

  char control_mode;

}
camera_t;

/* voir camera.c pour les descriptions de ces fonctions */
void cam_init ();
void cam_set_default_view ();
void cam_switch_control_mode ();
void cam_set_control_mode (int newmode);
int cam_get_control_mode ();
void cam_set_posf (float positionX, float positionY, float positionZ,
		   float viewX, float viewY, float viewZ,
		   float upVectorX, float upVectorY, float upVectorZ);
void cam_set_posv (vector3d_t pos, vector3d_t view, vector3d_t upvect);
vector3d_t cam_get_upvector (vector3d_t view, vector3d_t pos);
void cam_look ();
void cam_move_cam_forwbackw (float speed);
void cam_move_cam_updown (float speed);
void cam_strafe_cam_leftright (float speed);
void cam_rotate_terrain_leftright (float speed);
void cam_rotate_cam_updown (float speed);
void cam_rotate_cam_leftright (float speed);

#endif
