#include "../projet.h"

#ifdef USE_GLUT
TER_param_hyperb_t hyp_param;

void
glut_reshape(int w, int h)
{
  gl_generic_resize (w, h);
}

void
glut_display(void)
{
  gl_generic_render_scene();
   
  glutSwapBuffers(); 
}

void glut_idle(void)
{
  glutPostRedisplay();
}

void fill_default_hyperb_params (TER_param_hyperb_t *params)
{
  params->num_iter = 50;
  params->radius_min = 10;
  params->radius_max = 30;
  params->power = 0.3333;
  params->factor = 50;
  params->epsilon = ALGO_HYPERB_CRATERS | ALGO_HYPERB_SPHERES;
}

void glut_ui_keyboard(unsigned char key, int x, int y) {

	switch(key) {
		case 'q':
			cam_rotate_terrain_leftright (0.1); 
			break;
		case 'd':
			cam_rotate_terrain_leftright (-0.1); 
			break;
		case 'z':
			cam_move_cam_forwbackw (2);  
			break;
		case 's':
			cam_move_cam_forwbackw (-2);  
			break;
	}

}

void set_up_glut()
{   
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(800,600);
  glutCreateWindow("Terrain preview (GLUT)");
  gl_generic_init();
  
  /* parametres du terrain */
  terrain->size = 129;
  terrain->algo = TERR_HYPERB;
  fill_default_hyperb_params (&hyp_param);
  terrain->spec_param = (void *) &hyp_param;
  
  ui_generic_generate_new_terrain (terrain);

  glutDisplayFunc(glut_display);
  glutReshapeFunc(glut_reshape);
  glutIdleFunc(glut_idle);
  glutKeyboardFunc(glut_ui_keyboard);
}

#endif /* USE_GLUT */
