#include "projet.h"

#ifndef VERSION
#define VERSION "?.?.?"
#endif

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget *
create_about_dialog (void)
{
  GtkWidget *about_dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *aboutw_label_l1;
  GtkWidget *aboutw_label_l2;
  GtkWidget *aboutw_label_l3;
  GtkWidget *dialog_action_area1;
  GtkWidget *aboutw_okb;
  gchar *aboutw_text_l1;
  gchar *aboutw_text_l2;
  gchar *aboutw_text_l3;
  GtkWidget *aboutw_label_url;
  gchar *aboutw_url;

  about_dialog = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (about_dialog), 3);
  gtk_window_set_title (GTK_WINDOW (about_dialog), _("A propos..."));

  gtk_window_set_resizable (GTK_WINDOW (about_dialog), FALSE);

  dialog_vbox1 = GTK_DIALOG (about_dialog)->vbox;
  gtk_widget_show (dialog_vbox1);


  aboutw_text_l1 =
    g_strdup_printf (_("Générateur de terrains\n(projet PI4 2003)\n"));
  aboutw_label_l1 = gtk_label_new (aboutw_text_l1);

  aboutw_text_l2 =
    g_strdup_printf (_
		     ("Clément Bourdarias (phneutre@icculus.org)\nDavid Bonali (david.bonali@free.fr)\n")
    );
  aboutw_label_l2 = gtk_label_new (aboutw_text_l2);

  aboutw_text_l3 =
    g_strdup_printf (_("Téléchargement et informations :"));
  aboutw_label_l3 = gtk_label_new (aboutw_text_l3);

  aboutw_url =
    g_strdup_printf
    ("<span foreground=\"blue\"><u>http://icculus.org/~phneutre/terraingen</u></span>");
  aboutw_label_url = gtk_label_new (NULL);
  gtk_label_set_markup (GTK_LABEL (aboutw_label_url), aboutw_url);

  gtk_widget_show (aboutw_label_l1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), aboutw_label_l1, TRUE, FALSE,
		      3);

  gtk_widget_show (aboutw_label_l2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), aboutw_label_l2, TRUE, FALSE,
		      3);
          
  gtk_widget_show (aboutw_label_l3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), aboutw_label_l3, TRUE, FALSE,
		      3);        

  gtk_widget_show (aboutw_label_url);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), aboutw_label_url, TRUE, FALSE,
		      3);


  g_free (aboutw_text_l1);
  g_free (aboutw_text_l2);
  g_free (aboutw_text_l3);
  g_free (aboutw_url);

  dialog_action_area1 = GTK_DIALOG (about_dialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1),
			     GTK_BUTTONBOX_END);

  aboutw_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (aboutw_okb);
  gtk_dialog_add_action_widget (GTK_DIALOG (about_dialog), aboutw_okb,
				GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (aboutw_okb, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (about_dialog), "destroy",
		      GTK_SIGNAL_FUNC (on_about_dialog_destroy),
		      GTK_OBJECT (about_dialog));
  gtk_signal_connect (GTK_OBJECT (aboutw_okb), "clicked",
		      GTK_SIGNAL_FUNC (on_aboutw_okb_clicked),
		      GTK_OBJECT (about_dialog));

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (about_dialog, about_dialog, "about_dialog");
  GLADE_HOOKUP_OBJECT_NO_REF (about_dialog, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT_NO_REF (about_dialog, dialog_action_area1,
			      "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (about_dialog, aboutw_okb, "aboutw_okb");

  return about_dialog;
}
