#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget *
create_cal_window (void)
{
  GtkWidget *cal_window;
  GtkWidget *calw_mid_radiob;
  GtkWidget *calw_chx_lbl;
  GtkWidget *hseparator1;
  GtkWidget *hseparator2;
  GtkWidget *hseparator3;
  GtkWidget *calw_midp_rb;
  GSList *calw_midp_rb_group = NULL;
  GtkWidget *calw_hyp_rb;
  GtkWidget *calw_diam_rb;
  GtkWidget *calw_fault_rb;
  GtkWidget *calw_particle_rb;
  GtkWidget *calw_hbuttonbox1;
  GtkWidget *calw_valid_b;
  
  GtkWidget *calw_sizelbl;
  GtkWidget *calw_option1;
  GtkWidget *menusize;
  GtkWidget *calm_65;
  GtkWidget *calm_129;
  GtkWidget *calm_257;

  cal_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (cal_window), _("Algorithmes"));
  gtk_window_set_transient_for (GTK_WINDOW (cal_window),
				GTK_WINDOW (gl_window));
  

  calw_mid_radiob = gtk_vbox_new (FALSE, 9);
  gtk_widget_show (calw_mid_radiob);
  gtk_container_add (GTK_CONTAINER (cal_window), calw_mid_radiob);
  gtk_container_set_border_width (GTK_CONTAINER (calw_mid_radiob), 5);

  calw_chx_lbl = gtk_label_new (_("Choix de l'algorithme"));
  gtk_widget_show (calw_chx_lbl);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_chx_lbl, FALSE, FALSE,
		      0);
  gtk_label_set_justify (GTK_LABEL (calw_chx_lbl), GTK_JUSTIFY_LEFT);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), hseparator1, FALSE, FALSE,
		      0);

  calw_midp_rb =
    gtk_radio_button_new_with_mnemonic (NULL, _("Midpoint displacement"));
  gtk_widget_show (calw_midp_rb);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_midp_rb, FALSE, FALSE,
		      0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (calw_midp_rb),
			      calw_midp_rb_group);
  calw_midp_rb_group =
    gtk_radio_button_get_group (GTK_RADIO_BUTTON (calw_midp_rb));

  calw_hyp_rb = gtk_radio_button_new_with_mnemonic (NULL, _("Hyperboloides"));
  gtk_widget_show (calw_hyp_rb);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_hyp_rb, FALSE, FALSE,
		      0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (calw_hyp_rb),
			      calw_midp_rb_group);
  calw_midp_rb_group =
    gtk_radio_button_get_group (GTK_RADIO_BUTTON (calw_hyp_rb));

  calw_diam_rb =
    gtk_radio_button_new_with_mnemonic (NULL, _("Diamond-Square"));
  gtk_widget_show (calw_diam_rb);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_diam_rb, FALSE, FALSE,
		      0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (calw_diam_rb),
			      calw_midp_rb_group);
  calw_midp_rb_group =
    gtk_radio_button_get_group (GTK_RADIO_BUTTON (calw_diam_rb));

  calw_fault_rb = gtk_radio_button_new_with_mnemonic (NULL, _("Fault formation"));
  gtk_widget_show (calw_fault_rb);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_fault_rb, FALSE, FALSE,
		      0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (calw_fault_rb),
			      calw_midp_rb_group);
  calw_midp_rb_group =
    gtk_radio_button_get_group (GTK_RADIO_BUTTON (calw_fault_rb));
    
    calw_particle_rb = gtk_radio_button_new_with_mnemonic (NULL, _("Particle deposition"));
  gtk_widget_show (calw_particle_rb);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_particle_rb, FALSE, FALSE,
		      0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (calw_particle_rb),
			      calw_midp_rb_group);
  calw_midp_rb_group =
    gtk_radio_button_get_group (GTK_RADIO_BUTTON (calw_particle_rb));
    
  /*************/
  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), hseparator2, FALSE, FALSE,
		      0);

  calw_sizelbl = gtk_label_new (_("Taille du terrain"));
  gtk_widget_show (calw_sizelbl);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_sizelbl, FALSE, FALSE,
		      0);
  gtk_label_set_justify (GTK_LABEL (calw_sizelbl), GTK_JUSTIFY_LEFT);
  
  calw_option1 = gtk_option_menu_new ();
  gtk_widget_show (calw_option1);
  
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_option1, FALSE, FALSE,
		      0);  

  menusize = gtk_menu_new ();

  calm_65 = gtk_menu_item_new_with_mnemonic ("65 x 65");
  gtk_widget_show (calm_65);
  gtk_container_add (GTK_CONTAINER (menusize), calm_65);

  calm_129 = gtk_menu_item_new_with_mnemonic ("129 x 129");
  gtk_widget_show (calm_129);
  gtk_container_add (GTK_CONTAINER (menusize), calm_129);

  calm_257 = gtk_menu_item_new_with_mnemonic ("257 x 257");
  gtk_widget_show (calm_257);
  gtk_container_add (GTK_CONTAINER (menusize), calm_257);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (calw_option1), menusize);
  gtk_option_menu_set_history (GTK_OPTION_MENU (calw_option1), 1);
  /*************/
  
  hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), hseparator3, FALSE, FALSE,
		      0);
   

  calw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (calw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (calw_mid_radiob), calw_hbuttonbox1, FALSE,
		      FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (calw_hbuttonbox1),
			     GTK_BUTTONBOX_SPREAD);

  calw_valid_b = gtk_button_new_from_stock ("gtk-go-forward");
  gtk_widget_show (calw_valid_b);
  gtk_container_add (GTK_CONTAINER (calw_hbuttonbox1), calw_valid_b);
  GTK_WIDGET_SET_FLAGS (calw_valid_b, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) cal_window, "destroy",
		    G_CALLBACK (on_cal_window_destroy),
		    G_OBJECT (cal_window));
        
  g_signal_connect ((gpointer) calw_valid_b, "clicked",
		    G_CALLBACK (on_calw_valid_b_clicked),
		    G_OBJECT (cal_window));

  g_signal_connect ((gpointer) calw_midp_rb, "released",
		    G_CALLBACK (on_calw_midp_rb_released), NULL);

  g_signal_connect ((gpointer) calw_hyp_rb, "released",
		    G_CALLBACK (on_calw_hyp_rb_released), NULL);

  g_signal_connect ((gpointer) calw_diam_rb, "released",
		    G_CALLBACK (on_calw_diam_rb_released), NULL);
        
  g_signal_connect ((gpointer) calw_particle_rb, "released",
		    G_CALLBACK (on_calw_particle_rb_released), NULL);
        
  g_signal_connect ((gpointer) calw_fault_rb, "released",
		    G_CALLBACK (on_calw_fault_rb_released), NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (cal_window, cal_window, "cal_window");
  GLADE_HOOKUP_OBJECT (cal_window, calw_mid_radiob, "calw_mid_radiob");
  GLADE_HOOKUP_OBJECT (cal_window, calw_chx_lbl, "calw_chx_lbl");
  GLADE_HOOKUP_OBJECT (cal_window, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (cal_window, calw_midp_rb, "calw_midp_rb");
  GLADE_HOOKUP_OBJECT (cal_window, calw_hyp_rb, "calw_hyp_rb");
  GLADE_HOOKUP_OBJECT (cal_window, calw_diam_rb, "calw_diam_rb");
  GLADE_HOOKUP_OBJECT (cal_window, calw_particle_rb, "calw_particle_rb");
  GLADE_HOOKUP_OBJECT (cal_window, calw_fault_rb, "calw_fault_rb");
  GLADE_HOOKUP_OBJECT (cal_window, calw_option1, "calw_option1");
  GLADE_HOOKUP_OBJECT (cal_window, calw_hbuttonbox1, "calw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (cal_window, calw_valid_b, "calw_valid_b");

  return cal_window;
}
