#include "projet.h"

TER_param_hyperb_t hyp_param;

void
hpw_fill_params (GtkWidget * window)
{
  GtkSpinButton *spb;
  GtkCheckButton *cb1, *cb2;

  spb =
    GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_numitersb"));
  hyp_param.num_iter = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_rayminsb"));
  hyp_param.radius_min = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_raymaxsb"));
  hyp_param.radius_max = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_exposb"));
  hyp_param.power = (double) gtk_spin_button_get_value_as_float (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_factsb"));
  hyp_param.factor = gtk_spin_button_get_value_as_int (spb);

  cb1 = GTK_CHECK_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_cratersbox"));
  cb2 = GTK_CHECK_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_spheresbox"));

  hyp_param.epsilon = 0;
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(cb1)))
    hyp_param.epsilon |= ALGO_HYPERB_CRATERS;
  
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(cb2)))
    hyp_param.epsilon |= ALGO_HYPERB_SPHERES;
    
  /*g_print ("parameters: pow=%f, num_iter=%d, radmin=%d, radmax=%d\n",
	   hyp_param.power, hyp_param.num_iter, hyp_param.radius_min,
	   hyp_param.radius_max);*/
}

void
on_hpw_okb_clicked (GtkButton * button, gpointer user_data)
{
  /* recupere les parametres */
  hpw_fill_params (GTK_WIDGET (user_data));
  terrain->spec_param = (void *) &hyp_param;

  gtk_widget_destroy (GTK_WIDGET (user_data));

  gtkglw_activate_buttons();
  
  terrain->algo = TERR_HYPERB;  
  ui_generic_generate_new_terrain (terrain);
}
