#ifndef __PROJET_H__
#define __PROJET_H__

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef DONT_USE_GTK
 /* includes GTK et GtkGLExt*/
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>

#include <gtk/gtkgl.h>
#endif /* ifndef DONT_USE_GTK */

/* includes OpenGL communs */
#include <GL/gl.h>
#include <GL/glu.h>

#ifdef USE_GLUT
#include <GL/glut.h>
#endif /* ifdef USE_GLUT */

#ifdef USE_SDL
#include "SDL.h"
#endif /* ifdef USE_SDL */

/* include de libterrain */
#include "terrain/terrain.h"

#ifndef DONT_USE_GTK
/* includes specifiques  l'interface gtk2 */
#include "gtk2_ui/gtkglw.h"
#include "gtk2_ui/hyp_paraw.h"
#include "gtk2_ui/diamsq_paraw.h"
#include "gtk2_ui/middisp_paraw.h"
#include "gtk2_ui/fault_paraw.h"
#include "gtk2_ui/particle_paraw.h"
#include "gtk2_ui/chxalgow.h"
#include "gtk2_ui/filterw.h"
#include "gtk2_ui/aboutw.h"
#include "gtk2_ui/support.h"
#endif

/* includes communs */
#include "common_geometry.h"
#include "camera.h"
#include "colorschemes.h"
#include "tessellation.h"
#include "gl_generic.h"
#include "ui_generic.h"
#include "gl_intro.h"

/* le terrain sur lequel on travaille */
extern TER_terrain_t *terrain;

#endif
